<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for userConversationCountTypeList StructType
 * @subpackage Structs
 */
class UserConversationCountTypeList extends AbstractStructBase
{
    /**
     * The userConversationCountType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UserConversationCountType[]
     */
    public $userConversationCountType;
    /**
     * Constructor method for userConversationCountTypeList
     * @uses UserConversationCountTypeList::setUserConversationCountType()
     * @param \StructType\UserConversationCountType[] $userConversationCountType
     */
    public function __construct(array $userConversationCountType = array())
    {
        $this
            ->setUserConversationCountType($userConversationCountType);
    }
    /**
     * Get userConversationCountType value
     * @return \StructType\UserConversationCountType[]|null
     */
    public function getUserConversationCountType()
    {
        return $this->userConversationCountType;
    }
    /**
     * This method is responsible for validating the values passed to the setUserConversationCountType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserConversationCountType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserConversationCountTypeForArrayConstraintsFromSetUserConversationCountType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $userConversationCountTypeListUserConversationCountTypeItem) {
            // validation for constraint: itemType
            if (!$userConversationCountTypeListUserConversationCountTypeItem instanceof \StructType\UserConversationCountType) {
                $invalidValues[] = is_object($userConversationCountTypeListUserConversationCountTypeItem) ? get_class($userConversationCountTypeListUserConversationCountTypeItem) : sprintf('%s(%s)', gettype($userConversationCountTypeListUserConversationCountTypeItem), var_export($userConversationCountTypeListUserConversationCountTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The userConversationCountType property can only contain items of type \StructType\UserConversationCountType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set userConversationCountType value
     * @throws \InvalidArgumentException
     * @param \StructType\UserConversationCountType[] $userConversationCountType
     * @return \StructType\UserConversationCountTypeList
     */
    public function setUserConversationCountType(array $userConversationCountType = array())
    {
        // validation for constraint: array
        if ('' !== ($userConversationCountTypeArrayErrorMessage = self::validateUserConversationCountTypeForArrayConstraintsFromSetUserConversationCountType($userConversationCountType))) {
            throw new \InvalidArgumentException($userConversationCountTypeArrayErrorMessage, __LINE__);
        }
        $this->userConversationCountType = $userConversationCountType;
        return $this;
    }
    /**
     * Add item to userConversationCountType value
     * @throws \InvalidArgumentException
     * @param \StructType\UserConversationCountType $item
     * @return \StructType\UserConversationCountTypeList
     */
    public function addToUserConversationCountType(\StructType\UserConversationCountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UserConversationCountType) {
            throw new \InvalidArgumentException(sprintf('The userConversationCountType property can only contain items of type \StructType\UserConversationCountType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->userConversationCountType[] = $item;
        return $this;
    }
}
